## ros-kinetic-imagesift 1.2.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(imagesift)

# Use ccache if installed to make it fast to generate object files
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

find_package(catkin REQUIRED COMPONENTS roscpp sensor_msgs posedetection_msgs image_transport cv_bridge cmake_modules
  jsk_recognition_utils nodelet jsk_topic_tools)

find_package(OpenCV)

catkin_package(
    CATKIN_DEPENDS roscpp sensor_msgs posedetection_msgs image_transport cv_bridge
    LIBRARIES ${PROJECT_NAME}
    INCLUDE_DIRS include
    DEPENDS OpenCV
)

catkin_python_setup()

set(ENV{PKG_CONFIG_PATH} ${CATKIN_DEVEL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH})
find_package(PkgConfig REQUIRED)
pkg_check_modules(siftfast libsiftfast REQUIRED)

include_directories(include ${catkin_INCLUDE_DIRS} ${OpenCV_INCLUDE_DIRS} ${siftfast_INCLUDE_DIRS})
link_directories(${siftfast_LIBRARY_DIRS})
link_libraries(${catkin_LIBRARIES} ${OpenCV_LIBRARIES} ${siftfast_LIBRARIES})


macro(jsk_feature detector extractor exec_name)
  list(APPEND jsk_exec ${exec_name})
  set(DETECTOR ${detector})
  set(EXTRACTOR ${extractor})
  set(EXEC_NAME ${exec_name})
  configure_file(src/imagefeatures.cpp.in src/${exec_name}.cpp) #${CMAKE_CURRENT_BINARY_DIR}/
  add_executable(${exec_name} src/${exec_name}.cpp)
  # https://stackoverflow.com/questions/28939652/how-to-detect-sse-sse2-avx-avx2-avx-512-avx-128-fma-kcvi-availability-at-compile
  execute_process(
    COMMAND gcc -dM -E -
    COMMAND grep SSE
    INPUT_FILE /dev/null
    RESULT_VARIABLE GCC_SUPPORT_SSE)
  message(STATUS "Check GCC supports SSE ${GCC_SUPPORT_SSE}")
  if(NOT ${GCC_SUPPORT_SSE})
    set_target_properties(${exec_name} PROPERTIES COMPILE_FLAGS "-msse2 -O3" LINK_FLAGS "-msse2 -O3")
  endif()
  if($ENV{ROS_DISTRO} STREQUAL "groovy" OR $ENV{ROS_DISTRO} STREQUAL "hydro")
    set_target_properties(${exec_name} PROPERTIES COMPILE_FLAGS "-DOPENCV_NON_FREE")
  endif()
endmacro(jsk_feature detector extractor exec_name)

message(STATUS "OpenCV_VERSION: ${OpenCV_VERSION}")
if("${OpenCV_VERSION}" VERSION_LESS 3.0.0) # http://stackoverflow.com/questions/31509600/why-so-many-featuredetector-and-descriptorextractor-are-not-supported-in-opencv
jsk_feature("SURF" "SURF" "imagesurf")
jsk_feature("STAR" "SURF" "imagestar")
jsk_feature("SIFT" "SURF" "imagesift_surf")
jsk_feature("SIFT" "SIFT" "imagesift_sift")
jsk_feature("ORB" "ORB" "imageorb")
endif()
jsk_feature("BRISK" "BRISK" "imagebrisk")


jsk_nodelet(src/imagesift.cpp
  "imagesift/ImageSift"
  "imagesift"
  nodelet_sources nodelet_executables)

add_library(lib_${PROJECT_NAME} SHARED ${nodelet_sources})
set_target_properties(lib_${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

add_definitions("-O2 -g")
include_directories(include ${catkin_INCLUDE_DIRS})
target_link_libraries(lib_${PROJECT_NAME} ${catkin_LIBRARIES} ${OpenCV_LIBS})

# From https://github.com/jsk-ros-pkg/jsk_recognition/pull/2345
# Install header files directly into ${CATKIN_PACKAGE_INCLUDE_DESTINATION}.
# If the package has setup.py and modules under src/${PROJECT_NAME}/,
# install python executables directly into ${CATKIN_PACKAGE_BIN_DESTINATION}.
# However, if it doesn't have setup.py, directories including python executables
# should be installed recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Also, other directories like 'launch' or 'sample' must be installed
# recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Be careful that 'launch' and 'launch/' are different: the former is directory
# and the latter is each content.
install(TARGETS lib_${PROJECT_NAME} ${jsk_exec} ${nodelet_executables}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(FILES nodelet.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY sample test
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  if("$ENV{ROS_DISTRO}" STRGREATER "hydro")
    # FIXME: jsk_tools/test_topic_published.py does not work on hydro travis/jenkins
    # https://github.com/jsk-ros-pkg/jsk_common/pull/1293#issuecomment-164158260
    add_rostest(test/test_imagesift.test)
  endif()
endif()

=== debian/changelog ===
ros-kinetic-imagesift (1.2.15-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 10 Oct 2020 00:00:00 -0000

ros-kinetic-imagesift (1.2.14-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 09 Oct 2020 00:00:00 -0000

ros-kinetic-imagesift (1.2.13-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 08 Oct 2020 00:00:00 -0000

ros-kinetic-imagesift (1.2.12-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 03 Oct 2020 00:00:00 -0000

ros-kinetic-imagesift (1.2.11-1xenial) xenial; urgency=high

  * Fix for  noetic / 20.04 (#2507 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2507>)
    
      * imagesift/src/imagesift.cpp fix for opencv4
      * upgrade package.xml to format=3, migrate to noetic with ROS_PYTHON_VERSION=2/3, use multiple ROS distro strategy http://wiki.ros.org/noetic/Migration
    
  * fix generate_readme.py and update readme (#2442 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2442>)
  * Contributors: Kei Okada, Shingo Kitagawa, Yuki Furuta, Yuto Uchimi

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 01 Oct 2020 00:00:00 -0000

ros-kinetic-imagesift (1.2.10-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 27 Mar 2019 00:00:00 -0000

ros-kinetic-imagesift (1.2.9-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 23 Feb 2019 00:00:00 -0000

ros-kinetic-imagesift (1.2.8-1xenial) xenial; urgency=high

  * fix arm build regressions, closes #2396 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2396> (#2397 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2397> )
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 22 Feb 2019 00:00:00 -0000

ros-kinetic-imagesift (1.2.7-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 14 Feb 2019 00:00:00 -0000

ros-kinetic-imagesift (1.2.6-1xenial) xenial; urgency=high

  * Install 'sample' and 'test' dir into CATKIN_PACKAGE_SHARE_DESTINATION (#2345 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2345>)
  * fix for jsk-ros-pkg/jsk_common/pull/1586 (#2311 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2311>)
    * use lib_ instaed of  for add_library to avoid conflict
    * add version_gte for jsk_topic_tools
    * imagesift: fix for jsk-ros-pkg/jsk_common/pull/1586
  * Refactor CMakeLists.txt and package.xml of jsk_perception (#2279 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2279>)
  * Contributors: Fuki Furuta, Kei Okada, Kentaro Wada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 02 Nov 2018 00:00:00 -0000

ros-kinetic-imagesift (1.2.5-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 09 Apr 2018 00:00:00 -0000

ros-kinetic-imagesift (1.2.4-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 12 Jan 2018 00:00:00 -0000

ros-kinetic-imagesift (1.2.3-1xenial) xenial; urgency=high

  * imagesift: fix onInitPostProcess and poke (#2203 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2203>)
  * Contributors: Yuki Furuta

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 23 Nov 2017 00:00:00 -0000

ros-kinetic-imagesift (1.2.2-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 23 Jul 2017 00:00:00 -0000

ros-kinetic-imagesift (1.2.1-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 15 Jul 2017 00:00:00 -0000

ros-kinetic-imagesift (1.2.0-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 15 Jul 2017 00:00:00 -0000

ros-kinetic-imagesift (1.1.3-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 07 Jul 2017 00:00:00 -0000

ros-kinetic-imagesift (1.1.2-1xenial) xenial; urgency=high

  * Generate README by script
  * Contributors: Kentaro Wada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 16 Jun 2017 00:00:00 -0000

ros-kinetic-imagesift (1.1.1-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 04 Mar 2017 00:00:00 -0000

ros-kinetic-imagesift (1.1.0-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 09 Feb 2017 00:00:00 -0000

ros-kinetic-imagesift (1.0.4-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 09 Feb 2017 00:00:00 -0000

ros-kinetic-imagesift (1.0.3-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 08 Feb 2017 00:00:00 -0000

ros-kinetic-imagesift (1.0.2-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 12 Jan 2017 00:00:00 -0000

ros-kinetic-imagesift (1.0.1-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 13 Dec 2016 00:00:00 -0000

ros-kinetic-imagesift (1.0.0-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 12 Dec 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.29-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 30 Oct 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.28-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 29 Oct 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.27-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 29 Oct 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.26-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 27 Oct 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.25-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 16 Sep 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.24-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 15 Sep 2016 00:00:00 -0000

ros-kinetic-imagesift (0.3.23-1xenial) xenial; urgency=high





=== debian/control ===
Source: ros-kinetic-imagesift
Section: misc
Priority: optional
Maintainer: Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), python-setuptools, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-cv-bridge, ros-kinetic-image-transport, ros-kinetic-jsk-recognition-utils, ros-kinetic-jsk-topic-tools (>= 2.2.8), ros-kinetic-libsiftfast, ros-kinetic-nodelet, ros-kinetic-posedetection-msgs, ros-kinetic-roscpp, ros-kinetic-rostest, ros-kinetic-sensor-msgs
Homepage: https://jsk-docs.readthedocs.io/projects/jsk_recognition/en/latest/imagesift
Standards-Version: 3.9.2

Package: ros-kinetic-imagesift
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-cv-bridge, ros-kinetic-image-transport, ros-kinetic-jsk-recognition-utils, ros-kinetic-jsk-topic-tools (>= 2.2.8), ros-kinetic-libsiftfast, ros-kinetic-nodelet, ros-kinetic-posedetection-msgs, ros-kinetic-roscpp, ros-kinetic-sensor-msgs
Description: For every image, computes its sift features and send a new message with the image, its intrinsic parameters, and the features.
 Parameters include: display - shows the image on the local computer

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-imagesift//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
